package itso.servjsp.servletapi;

import java.io.*;
import java.util.*;
import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class UserSessionCounter extends HttpServlet {
	private int calledCount;

public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	res.setContentType("TEXT/HTML"); 
	PrintWriter out = res.getWriter();
	 
	HttpSession session = req.getSession(true);  
	if (session.isNew() || session.getValue("usersession")==null) {
		session.putValue("usersession", new SaveServletStats());  
	}
	SaveServletStats ustats =
			   (SaveServletStats)session.getValue("usersession");
	calledCount++;
	ustats.calledCount++;
	out.println("<HTML><TITLE>SessionCounter</TITLE><BODY>");  
	out.println("<H4>This servlet has been called: </H4><BR>");
	out.println("<B>" + calledCount + "</B> times since the servlet was loaded THIS servlet life-cycle session<BR>");
	out.println("<B>" + ustats.calledCount + "</B> times since the servlet was loaded by this user<BR>");
	out.println("</BODY></HTML>");
	out.close();
}
public void init(ServletConfig config) throws ServletException {
	super.init(config);
	calledCount = 0;
}
}
