package itso.servjsp.servletapi;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class UserSessionCounterGetter extends HttpServlet {
public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	res.setContentType("TEXT/HTML"); 
	PrintWriter out = res.getWriter();
	 
	HttpSession session = req.getSession(true);  
	if (session.isNew() || session.getValue("usersession")==null) {
		session.putValue("usersession", new SaveServletStats());  
	}
	SaveServletStats ustats = (SaveServletStats)session.getValue("usersession");

	out.println("<HTML><TITLE>SessionCounter</TITLE><BODY>");  
	out.println("<H4>SessionCounter - UserSessionCounterGetter servlet</H4>");  	
	out.println("<B>" + ustats.calledCount + "</B> times since the UserSessionCounter servlet was loaded by this user<BR>");
	out.println("</BODY></HTML>");
	out.close();
}
}
