<%
//        Please read this notice....
//
//        This JSP is provided on an AS-IS basis.  Please address questions and comments
//        to Chris Gerken (cgerken@us.ibm.com).
//
//        To install this JSP...
//
//          1) Place the JSP in the WebServer's (e.g. for IBM HTTP or Apache) docroot
//          2) If you have not installed the initial configuration (stuff like snoopServlet,
//             showCfg and other sample web apps, set install.initial.config=true in 
//             WebSphere/AppServer/bin/admin.config and restart WebSphere.
//          3) request http://<<yourhost>>/WebPaths.jsp
//
//
//        Also... I know this JSP is really ugly, but I wanted an easy-to-install JSP...

%>
<%@ import ="org.w3c.dom.*,com.ibm.websphere.xmlconfig.*,com.ibm.xml.parser.*"  %>

<%
try {

String nodename = request.getParameter("node");
if (nodename == null) { nodename = request.getHeader("Host"); }

String edition = request.getParameter("edition");
if (edition == null) { edition = "advanced"; }
boolean advanced = edition.equals("advanced");
String seladv = advanced ? "selected" : "";
String selstd = advanced ? "" : "selected";

String namesrvr = request.getParameter("namesrvr");
if (namesrvr == null) { namesrvr = nodename; }

String nameport = request.getParameter("nameport");
if (nameport == null) { nameport = "900"; }
int port = Integer.parseInt(nameport);
nameport = String.valueOf(port);

String testurl = request.getParameter("testurl");
if (testurl == null) { testurl = ""; }
boolean haveUrl = testurl.length() > 0;

String showx = request.getParameter("showxml");
if (showx == null) { showx = "false"; }
boolean showxml = showx.equals("true");

XMLConfig config = new XMLConfig(nodename,advanced,namesrvr,port);
TXDocument doc = config.executeFullExport(); 

Node node = null;
NodeList nodelist = null;
NodeList hosts = null;
TXElement element = null;
TXText text = null;
%>
<HEAD>
<TITLE>WebSphere Web Path Configuration</TITLE>
</HEAD>
<BODY>
<H2>Web Path Information</H2>
<p>In order to view configuration information that explains how WebSphere interprets and
processes URLs, you must first provide enough information below to connect to and query 
the admin repository.  Enter a test URL to determine the servlet that would be
invoked in response to that URL.</P>
<P>Note: You can click on "Nodes" under the Types tab in the Admin Console 
for a list of nodes.
<FORM method="POST" action="/WebPaths.jsp">
<table border=0>
<tr><td>
<table border=1 BGCOLOR="#COCO9O">
  <tr>
    <td>Name of one of the nodes (machines) in the WebSphere domain</td>
    <td><INPUT TYPE="TEXT"   NAME="node"   MAXLENGTH= "20" VALUE= "<%= nodename %>"></td>
    </tr>
  <tr>
    <td>WebSphere edition</td>
    <td><select name=edition>
          <option value="standard" <%= selstd %> >Standard
          <option value="advanced" <%= seladv %> >Advanced
          </select></td>
    </tr>
  <tr>
    <td>TCP/IP host name of the Object Name Server</td>
    <td><INPUT TYPE="TEXT"   NAME="namesrvr"   MAXLENGTH= "20" VALUE= "<%= namesrvr %>"></td>
    </tr>
  <tr>
    <td>TCP/IP port name of the Object Name Server</td>
    <td><INPUT TYPE="TEXT"   NAME="nameport"   MAXLENGTH= "20" VALUE= "<%= nameport %>"></td>
    </tr>
</table>
</td></tr><tr><td>
<table border=1 BGCOLOR="#COCO9O"  width="100%">
  <tr>
    <td>Optional test URL</td>
    <td><INPUT TYPE="TEXT"   NAME="testurl"   MAXLENGTH= "200" size=40 VALUE= "<%= testurl %>"></td>
    </tr>
</table>
</tr></td><tr><td>
<table border=0 width="100%">
  <tr>
    <td align=center>
      <INPUT TYPE="SUBMIT" NAME="submit"  Value="Get Configuration">
      <INPUT TYPE="RESET" NAME="reset"  Value="Reset">
    </td>
    </tr>
</table>
</tr></td>
</table>
</FORM>
<hr>
<% 
if (doc.getElementsByTagName("node").getLength() > 0) { 

   String vhost = null;
   String alias = null;
   String uriName = null;
   String rootURI = null;
   String appServer = null;
   String servletEngine = null;
   String webApp = null;
   String servlet = null;
   String webPath = null;
   String description = null;
   String key = null;
   String webAppKey = null;
   String servletKey = null;
   String servletName = null;
   String docRoot = null;
   String code = null;
   String stuff = null;
   int    webAppIndex = 0;
   int    servletIndex = 0;
   Hashtable codes = new Hashtable();
   Hashtable aliases = new Hashtable();
   Hashtable queues = new Hashtable();
   Hashtable squeues = new Hashtable();
   Hashtable webApps = new Hashtable();
   Hashtable ht = null;
   Hashtable bests = new Hashtable();
   Hashtable servletTable = new Hashtable();
   Vector servletInfo = null;

   Stack stack = new Stack();
   stack.push(doc);

   while (!stack.empty()) {
      node = (Node) stack.pop();
      String desc = node.getNodeName();
      if (desc.equals("virtual-host")) {
         element = (TXElement) node;
         vhost = element.getAttribute("name");
         queues.put(vhost,new Vector());
      }
      if (desc.equals("alias")) {
         element = (TXElement) node;
         alias = element.getText();
         Vector list = (Vector) aliases.get(vhost);
         if (list == null) {
            list = new Vector();
            aliases.put(vhost,list);
         }
         list.addElement(alias);
      }
      if (desc.equals("servlet")) {
         element = (TXElement) node;
         servlet = element.getAttribute("name");
         servletIndex = servletIndex + 1;
         servletKey = "servlet"+servletIndex;
         ht = new Hashtable();
         ht.put("name",servlet);
         servletTable.put(servletKey,ht);
         servletInfo = new Vector();
         servletInfo.addElement(new Vector());  
         servletInfo.addElement(servletKey);  
         servletInfo.addElement("&nbsp;");  
         servletInfo.addElement(webAppKey); 
         servletInfo.addElement(rootURI); 
         servletInfo.addElement(servletEngine);  
         servletInfo.addElement(appServer);  
         ((Vector)queues.get(key)).addElement(servletInfo);
      }
      if (desc.equals("description")) {
         element = (TXElement) node;
         if (node.getParentNode().getNodeName().equals("servlet")) {
            description = element.getText();
            servletInfo.setElementAt(description,2);
         }
      }
      if (desc.equals("uri")) {
         element = (TXElement) node;
         if (node.getParentNode().getNodeName().equals("virtual-host")) {
            uriName = element.getAttribute("name");
            rootURI = element.getAttribute("rootURI");
         }
         if (node.getParentNode().getNodeName().equals("uri-paths")) {
            webPath = element.getAttribute("value");
            if (webPath.charAt(0) != '/') { webPath = "/" + webPath; }
            webPath = rootURI+webPath;
            if ((webPath.length() > 1) && (webPath.substring(0,2).equals("//"))) { webPath = webPath.substring(1); }
            ((Vector)servletInfo.elementAt(0)).addElement(webPath);
         }
      }
      if (desc.equals("document-root")) {
         element = (TXElement) node;
         docRoot = element.getText();
         ht = (Hashtable) webApps.get(webAppKey);
         ht.put("document-root",docRoot);
      }
      if (desc.equals("code")) {
         element = (TXElement) node;
         code = element.getText();
         ht = (Hashtable) servletTable.get(servletKey);
         ht.put("code",code);
      }
      if (desc.equals("application-server")) {
         element = (TXElement) node;
         appServer = element.getAttribute("name");
      }
      if (desc.equals("servlet-engine")) {
         element = (TXElement) node;
         servletEngine = element.getAttribute("name");
      }
      if (desc.equals("web-application")) {
         element = (TXElement) node;
         webApp = element.getAttribute("name");
         webAppIndex = webAppIndex + 1;
         webAppKey = "webApp"+webAppIndex;
         ht = new Hashtable();
         ht.put("name",webApp);
         webApps.put(webAppKey,ht);
      }
      if (desc.equals("root-uri")) {
         element = (TXElement) node;
         rootURI = element.getText();
         int index = rootURI.indexOf("/");
         key = rootURI.substring(0,index);
         rootURI = rootURI.substring(index);
      }

      if (node.hasChildNodes()) {
         NodeList nodes = node.getChildNodes();
         for (int index = nodes.getLength()-1; index > -1; index--) {
            stack.push(nodes.item(index));
         }
      }
   }
%>
<H2>Interpreting URL requests</H2>
<% if (haveUrl) {  %>
<P>The table below shows how the test URL <b><%= testurl %></B> would be processed by each
virtual host.</p>
<% } %>
<%
   for (Enumeration vhse = queues.keys(); vhse.hasMoreElements(); ) {
      String vh = (String) vhse.nextElement();
      Vector temp = new Vector();
      Vector webPaths = (Vector)queues.get(vh);
      int bestPrefix = -1;
      int bestSuffix = -1;
      Vector best = null;
      for (Enumeration enum1 = webPaths.elements(); enum1.hasMoreElements(); ) {
         servletInfo = (Vector) enum1.nextElement();
         servletKey = (String) servletInfo.elementAt(1);
         ht = (Hashtable) servletTable.get(servletKey);
         code = (String)ht.get("code");
         servlet = (String)ht.get("name");
         description = (String) servletInfo.elementAt(2);
         webAppKey = (String) servletInfo.elementAt(3);
         webApp = (String)((Hashtable)webApps.get(webAppKey)).get("name");
         rootURI = (String) servletInfo.elementAt(4);
         servletEngine = (String) servletInfo.elementAt(5);
         appServer = (String) servletInfo.elementAt(6);
         for (Enumeration enum2 = ((Vector)servletInfo.elementAt(0)).elements(); enum2.hasMoreElements(); ) {
            Vector temp1 = new Vector();
            String pattern = (String) enum2.nextElement();
            temp1.addElement(pattern);
            temp1.addElement(servletKey);
            temp1.addElement(description);
            temp1.addElement(webApp);
            temp1.addElement(rootURI);
            temp1.addElement(servletEngine);
            temp1.addElement(appServer);

            boolean matched = true;
            int urllen = testurl.length();
            int offset = pattern.indexOf('*');
            if (offset < 0) { pattern = pattern + "*"; }
            offset = pattern.indexOf('*');
            int patlen = offset;
            String prefix = pattern.substring(0,offset);
            matched = (patlen <= urllen) && prefix.equalsIgnoreCase(testurl.substring(0,patlen));
            if (patlen < urllen) { matched = matched && ((testurl.charAt(patlen-1)=='/') | (testurl.charAt(patlen)=='/')); }
            int suflen = pattern.length() - patlen - 1;
            if (suflen > 0) { matched = matched && (testurl.length() > pattern.length()) && (pattern.substring(pattern.length()-suflen).equalsIgnoreCase(testurl.substring(testurl.length()-suflen))); }
            stuff = "";
            if (matched && pattern.charAt(patlen-1) == '/') { patlen = patlen - 1; };
            if (matched) { stuff = testurl.substring(patlen); }
            temp1.addElement(matched ? "Yes" : "");
            temp1.addElement(code);
            temp1.addElement(stuff);
            temp1.addElement(webAppKey);
            temp.addElement(temp1);
            if (matched) {
               if ((patlen > bestPrefix) | ((patlen == bestPrefix) && (suflen > bestSuffix))) {
                  best = temp1;
                  bestPrefix = patlen;
                  bestSuffix = suflen;
               }
            }
         }
      }
      if (best != null) { bests.put(vh,best); }
      Vector vhs = temp;

      Vector sorted = new Vector();
      while (!vhs.isEmpty()) {
         Vector champ = (Vector) vhs.elementAt(0);
         for (Enumeration enum = vhs.elements(); enum.hasMoreElements(); ) {
            Vector candidate = (Vector) enum.nextElement();
            String ch = (String) champ.elementAt(0);
            String ca = (String) candidate.elementAt(0);
            if (ch.toLowerCase().compareTo(ca.toLowerCase()) > 0) { champ = candidate; }
         }
         vhs.removeElement(champ);
         sorted.addElement(champ);
      }
      vhs = sorted;
      squeues.put(vh,sorted);
   } // added
   

%>
<h3 refid="vhosts">Virtual host aliases</h3>
<table border=1  BGCOLOR="#COCO9O">
<tr>
   <th>Host names</th>
   <th>Virtual Host</th>
<% if (haveUrl) { %>
   <th align=left >Servlet processing for <%= testurl %> </th>
<% } %>
   </tr>
<%
   for (Enumeration enum = aliases.keys(); enum.hasMoreElements(); ) {
      vhost = (String) enum.nextElement();
      out.println("<tr><td valign=top><ul>");
      for (Enumeration enum1 = ((Vector)aliases.get(vhost)).elements(); enum1.hasMoreElements(); ) {
         out.println("<li>"+(String)enum1.nextElement()+"</li>");
      }
      out.println("</ul></td><td valign=top>"+vhost+"</td>");
      if (haveUrl) { 
         servletInfo = (Vector) bests.get(vhost);
         out.println("<td valign=top>");
         if (servletInfo == null) {
            out.println("No servlets had a web path that matched the test URL.<BR><BR>The WebServer (e.g. IBM HTTP Server) will probably attempt to serve "+testurl+" out of its docroot.");
         } else {
            code = (String) servletInfo.elementAt(8);
            stuff = (String) servletInfo.elementAt(9);
            webAppKey = (String) servletInfo.elementAt(10);
            ht = (Hashtable) webApps.get(webAppKey);
            docRoot = (String) ht.get("document-root");
            boolean ibmServlet = false;
            servletKey = (String) servletInfo.elementAt(1);
            ht = (Hashtable) servletTable.get(servletKey);
            servletName = (String) ht.get("name");
            description = (String) servletInfo.elementAt(2);
            webApp = (String) servletInfo.elementAt(3);
            if (code.equals("com.ibm.servlet.jsp.http.pagecompile.PageCompileServlet")) {
               ibmServlet = true;
               out.println("<b>"+description+"</b><BR><BR>Web Application: <b>"+webApp+"</b><BR>WebApp DocRoot: <b>"+docRoot+"</b><BR>Relative filepath: <b>"+stuff+"</b><BR><BR>File <b>"+docRoot+stuff+"</b> will be processed as a JSP .91 file");
            }
            if (code.equals("com.sun.jsp.runtime.JspServlet")) {
               ibmServlet = true;
               out.println("<b>"+description+"</b><BR><BR>Web Application: <b>"+webApp+"</b><BR>WebApp DocRoot: <b>"+docRoot+"</b><BR>Relative filepath: <b>"+stuff+"</b><BR><BR>File <b>"+docRoot+stuff+"</b> will be processed as a JSP 1.0 file");
            }
            if (code.equals("com.ibm.servlet.engine.webapp.DefaultErrorReporter")) {
               ibmServlet = true;
               out.println("<b>"+description+"</b><BR><BR>Web Application: <b>"+webApp+"</b><BR><BR>Invokes default error page processing");
            }
            if (code.equals("com.ibm.servlet.engine.webapp.SimpleFileServlet")) {
               ibmServlet = true;
               out.println("<b>"+description+"</b><BR><BR>Web Application: <b>"+webApp+"</b><BR>WebApp DocRoot: <b>"+docRoot+"</b><BR>Relative filepath: <b>"+stuff+"</b><BR><BR>File <b>"+docRoot+stuff+"</b> will be returned in the HTTP response");
            }
            if (code.equals("com.ibm.servlet.engine.webapp.InvokerServlet")) {
               ibmServlet = true;
               out.println("<b>"+description+"</b><BR><BR>Web Application: <b>"+webApp+"</b><BR>Fully qualified classname: <b>"+stuff+"</b><BR><BR>Servlet class <b>"+stuff+"</b> will be loaded from the web app's classpath, instantiated and invoked");
            }
            if (!ibmServlet) {
               out.println("<b>"+description+"</b><BR><BR>Web Application: <b>"+webApp+"</b><BR>Fully qualified classname: <b>"+code+"</b><BR>WebApp DocRoot: <b>"+docRoot+"</b><BR>Partial URI after web path: <b>"+stuff+"</b>");
            }
         }
         out.println("</td>"); 
      }
      out.println("</tr>");
   }
%>
</table>
<%
   for (Enumeration vhse = squeues.keys(); vhse.hasMoreElements(); ) {
      String vh = (String) vhse.nextElement();
      Vector vhs = (Vector)squeues.get(vh);
%>
<h3>URI's defined for virtual host <%= vh %> </h3> 
<table border=1  BGCOLOR="#COCO9O">
<tr>
   <th>Servlet Web Paths</th>
   <th>Name</th>
   <th>Description</th>
   <th>Web App</th>
   <th>Root URI</th>
   <th>Servlet Engine</th>
   <th>Application Server</th>
   </tr>
<%
   for (Enumeration enum1 = vhs.elements(); enum1.hasMoreElements(); ) {
      servletInfo = (Vector) enum1.nextElement();
      webPath = (String) servletInfo.elementAt(0);
      servletKey = (String) servletInfo.elementAt(1);
      ht = (Hashtable) servletTable.get(servletKey);
      servlet = (String) ht.get("name");
      description = (String) servletInfo.elementAt(2);
      webApp = (String) servletInfo.elementAt(3);
      rootURI = (String) servletInfo.elementAt(4);
      servletEngine = (String) servletInfo.elementAt(5);
      appServer = (String) servletInfo.elementAt(6);
      out.println("<tr><td valign=top>"+webPath+"</td><td valign=top>"+servlet+"</td><td valign=top>"+description+"</td><td valign=top>"+webApp+"</td><td valign=top>"+rootURI+"</td><td valign=top>"+servletEngine+"</td><td valign=top>"+appServer+"</td></tr>");
   }
%>
</table>

<%
   } 
%>


<%

   if (showxml) {

   stack = new Stack();
   Stack depth = new Stack();
   stack.push(doc);
   depth.push("");

   while (!stack.empty()) {
      node = (Node) stack.pop();
      String indent = (String) depth.pop();
      String desc = node.getNodeName();
      if (node.getNodeType() == 1) { 
         desc = "<BR>"+indent+((TXElement)node).getTagName();
         NamedNodeMap map = ((TXElement)node).getAttributes(); 
         for (int index = 0; index < map.getLength(); index++) {
            Node mapNode = map.item(index);
            desc = desc + " " + mapNode.getNodeName() + "=\"" + mapNode.getNodeValue() + "\"";
         }
      }
      if (node.getNodeType() == 3) { 
         desc = "text= "+((TXText)node).getText(); 
         indent = "";
      }
      out.println(desc);
      if (node.hasChildNodes()) {
         NodeList nodes = node.getChildNodes();
         for (int index = nodes.getLength()-1; index > -1; index--) {
            stack.push(nodes.item(index));
            depth.push(indent+"*&nbsp;");
         }
      }
   }

   }

%>
<H3>Where the configuration is specified</H3>
<p>The information (both specific attributes and relationships between objects)
above is specified in a number of places throughout the WebSphere
Admin Console.  The table below shows how the administrator can enter or modify
this configuration.</P>
<h4>Virtual Hosts</h4>
<p>Virtual Hosts can be added using the "Configure a Virtual Host" task under the tasks
tab.
<h4>Host Names and Virtual Hosts</h4>
<p>The host names associated with a virtual host can be viewed and changed from the 
Advanced tab when the virtual host is selected under the Topology tab.
<h4>Servlet web paths, description and name</h4>
<p>Servlet attributes, such as web paths, description and name, can be viewed and
modified under the General tab when the servlet is selected under the Topology tab.
<H4 refid="webpath">Web Application's web path</h4>
<p>The web path for a web application is a prefix for the URL's for all resources
(html, JSP's, servlets) in the web application.  The web path follows the host name
in a fully qualified URL.</P>
<P>To view or set a web application's web path, select the web app in the Admin Console
and select its General page.  The web path is the last attribute listed on the page. </P>
</HTML>

<% } else {  %>
<H2>No Configuration Data Found</H2>
<p>This tool was unable to get WebSphere configuration data using the above connection
information.  Please recheck the settings and try again.</P> 

<%   } } catch ( Throwable t ) { out.println(t); }  %>