<!-- 
   Simple error page for reporting application errors.
   This error page is called when a servlet throws an Exception, or by calling
   response.sendError().  Error pages can use the request-scoped bean named
   "error" to get more information about the error.
--->

<BEAN name="error" type="com.ibm.websphere.servlet.error.ServletErrorReport" scope="request"></BEAN>
<html>
<head><title>Error <%= error.getMessage() %></title></head>
<body>

<H1>Error <%= error.getErrorCode() %> </H1>
<H4>An error has occured while processing request: <%= HttpUtils.getRequestURL(request) %></H4>

<B>Message: </B><%= error.getMessage() %><BR>
<B>StackTrace: </B><%= error.getStackTrace() %> 

</html>
