package itso.servjsp.studio;

import java.sql.*;
import java.io.*;
 
public class PhotoLoad {
	static FileInputStream sig = null;
	static PreparedStatement updStat = null;

public PhotoLoad() {
	super();
}

public static void main(java.lang.String[] args) {
	System.out.println("Start...");
	try {
		Class.forName("COM.ibm.db2.jdbc.app.DB2Driver").newInstance();
		Connection conn = DriverManager.getConnection("jdbc:db2:sample","ITSO","itso");
		Statement stat = conn.createStatement();
		String updString = "update userid.emp_photo set picture = cast(? as blob(110K)) where empno = ?";
		updStat = conn.prepareStatement(updString);

		update("999001");
		update("999006");
		
		updStat.close();
		conn.close();
	}
	catch (SQLException e1) {
		System.out.println("SQLState: "+e1.getSQLState());
		System.out.println("Message:  "+e1.getMessage());
		System.out.println(e1);
	}
	catch (Exception e2) {
		System.out.println(e2);
	}
}

private static void update(String empno) throws Exception {
	updStat.setString(2,empno);
	File image = new File(empno + ".gif");
	int lg = (new Long(image.length())).intValue();
	sig = new FileInputStream(image);
	updStat.setBinaryStream(1,sig,lg);
	updStat.executeUpdate();
	System.out.println("Updated employee " + empno);
}
}