package itso.servjsp.jspsamples;

import java.util.*;
 
public class DateDisplayBean {
	private int counter = 0;
	private String dateString = null;

public DateDisplayBean() {
	super();
	// Setup a property to hold the date as a string
	dateString = buildDateString(new GregorianCalendar());
	counter = 0;
}
public String buildDateString(GregorianCalendar gcalendar) {
	StringBuffer dateStr = new StringBuffer();
	dateStr.append(gcalendar.get(Calendar.DATE));	
	dateStr.append("/");
	dateStr.append(gcalendar.get(Calendar.MONTH) + 1);
	dateStr.append("/");	
	dateStr.append(gcalendar.get(Calendar.YEAR));	
	return dateStr.toString();
}
public int getCounter() {
	return counter;
}
public java.lang.String getDateString() {
	// Bump the counter
	counter++;
	return dateString;
}
public void setCounter(int newCounter) {
	counter = newCounter;
}
}
