package itso.servjsp.servletapi;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CookieServlet extends HttpServlet {
private String getReqCookie(HttpServletRequest req, PrintWriter out, String name) {
	Cookie[] cookies = req.getCookies();
		if(cookies != null && cookies.length > 0) {
			for(int i=0; i<cookies.length; i++) {
				if (cookies[i].getName().equals(name))
				    return (cookies[i].getValue());					
			}
		}
	return null;
}
protected void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	int calledCount = 0;
	res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	out.println("<HTML><TITLE>CookiesServlet</TITLE><BODY>");
	out.println("<H2>Servlet Cookie Example:</H2><HR>");
	if (getReqCookie(req, out, "calledCount") == null)
		calledCount = 0;
	else	
		calledCount = new Integer(getReqCookie(req, out, "calledCount")).intValue();
	out.print("The value of the cookie 'calledCount' sent in on the request: ");
	if (calledCount == 0) out.println("null - value not sent in on request<HR>");
	else out.println(calledCount + "<HR>");
	calledCount++;
	Cookie cookie = new Cookie("calledCount", new Integer(calledCount).toString()); 
	res.addCookie(cookie);
	out.println("The value of the cookie 'calledCount' set on the response: " + calledCount);
	out.println("</BODY><HTML>");
	out.close();
}
}
