package itso.servjsp.servletapi;

import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class JDBCInitServlet extends SimpleInitServlet {
	protected Connection conn = null;
	
public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	res.setContentType("TEXT/HTML");
	PrintWriter out = res.getWriter();

	out.println("<HTML>");  
	out.println("<TITLE>JDBC Init Connection</TITLE>");
	out.println("<BODY>");

	try { executeSQL(out); }
	catch (SQLException se) { se.printStackTrace(); }
		
	out.println("</BODY></HTML>");
	out.close();
}
public void executeSQL(PrintWriter out) throws SQLException{
	Statement stmt = conn.createStatement();
	String sql = "SELECT * FROM DEPARTMENT";
	stmt.executeQuery(sql);
	ResultSet rs = stmt.getResultSet();
	
	int count = 1;
	while (rs.next()) {
		out.println("<B>" + rs.getString("DEPTNAME") + "</B><BR><BLOCKQUOTE>");	
		String sql2 = "SELECT * FROM EMPLOYEE WHERE WORKDEPT = '" + rs.getString("DEPTNO") + "'";
		Statement stmt2 = conn.createStatement();
		stmt2.executeQuery(sql2);
		ResultSet rs2 = stmt2.getResultSet();
		while(rs2.next()) {
			out.println(rs2.getString("FIRSTNME") + " " + rs2.getString("LASTNAME") + "<br>");
		}
		out.println("</BLOCKQUOTE>");
	}

}
public void init(ServletConfig config) throws ServletException {
	super.init(config);
	try {
		//Loading driver dynamically, registers w/DriverManager
		Class.forName(mydriver).newInstance();  
		conn = DriverManager.getConnection(myurl, "itso", "itso");
	    System.out.println("Connection successful..");	
	}
	catch (SQLException se) { System.out.println(se); }
	catch (Exception e)     { e.printStackTrace(); }				
}
}
