package itso.servjsp.servletapi;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class SimpleInitServlet extends HttpServlet {
	
	protected String mydriver;
	protected String myurl;
	protected String myuserID;
	protected String mypassword;
public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	
	res.setContentType("TEXT/HTML");
	PrintWriter out = res.getWriter();

	out.println("<HTML>");
	out.println("<TITLE>Date Display</TITLE>"); 
	out.println("<BODY>");

	out.println("<H2>Servlet Initialization Parameters (ServletConfig): </H2><HR>");
	out.println("<B>driver: </B>" + mydriver + "</BR>");
	out.println("<B>url: </B>" + myurl + "</BR>");
	out.println("<B>password: </B>" + mypassword + "</BR>");
	out.println("<B>userID: </B>" + myuserID + "</BR>");
	
	out.println("</BODY></HTML>");
	out.close();

} //end of doGet
public void init(ServletConfig config) throws ServletException {
	
	super.init(config);
	
	mydriver = config.getInitParameter("driver");  
	myurl = config.getInitParameter("URL");
	myuserID = config.getInitParameter("userID");
	mypassword = config.getInitParameter("password");
		
}
}
